#ifndef GLOBALS_H
#define GLOBALS_H
#include <dlfcn.h>
#include <map>
#include <string>
#include <vector>
#include "object.h"

// Functions addresses
typedef std::multimap<std::string,Func> G_funcsType;
extern G_funcsType G_funcs;

// Types for variables and printsave store
typedef std::map<std::string,ExecExpr> VarType;
typedef std::vector<ExecExpr> ExecType;

// Loaded modules
typedef std::vector<void*> G_libsType;
extern G_libsType G_libs;

void ClearGlobals();

bool Save(const ObjectList* input);
bool Print(const ObjectList* input);

#endif
